=== dist/src/github.com/CanonicalLtd/go-dqlite/Makefile ===
proto:
	protoc --gogofast_out=. internal/protocol/commands.proto

.PHONY: proto
