=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.2.1
Homepage: https://linuxcontainers.org/
Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 10),
               dh-apparmor,
               dh-golang,
               golang-1.10-go,
               help2man,
               libacl1-dev,
               libcap-dev,
               libuv1-dev,
               lxc-dev (>= 1.1.0~),
               pkg-config,
               python3-lxc,
               tcl8.6-dev
XS-Go-Import-Path: github.com/lxc/lxd

Package: lxd-client
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: lxd
Breaks: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Replaces: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: acl,
         adduser,
         dnsmasq-base,
         ebtables,
         iproute2,
         iptables,
         liblxc1 (>= 3.0.0~),
         lsb-base (>= 3.0-6),
         lxcfs (>= 3.0.0~),
         lxd-client (= ${binary:Version}),
         passwd (>= 1:4.1.5.1-1ubuntu5~),
         rsync,
         squashfs-tools,
         uidmap (>= 1:4.1.5.1-1ubuntu5~),
         xdelta3,
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Recommends: apparmor
Suggests: criu, lxd-tools
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

Package: lxd-tools
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: python3, python3-lxc, ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Container hypervisor based on LXC - extra tools
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains extra tools provided with LXD.
  - fuidshift - A tool to map/unmap filesystem uids/gids
  - lxc-to-lxd - A tool to migrate LXC containers to LXD
  - lxd-benchmark - A benchmarking tool for LXD
