=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://linuxcontainers.org/lxd/downloads/ /downloads/lxd/lxd-(.*)\.tar\.gz
